#Played Script
#By Einlanzers

import esm
import time
import os
from java import io

def save_gametime():
  output = io.ObjectOutputStream(io.FileOutputStream("played.dat"))
  output.writeObject(gametime)
  output.close()

def load_gametime():
  if not os.path.exists("played.dat"):
    return {}
  input = io.ObjectInputStream(io.FileInputStream("played.dat"))
  obj = input.readObject()
  input.close()
  return obj

gametime = load_gametime()
jointime = {}

def player_join(ev):
  player = ev.getPlayer()
  name = player.getDisplayName()
  jointime[name] = int(time.time())
  return True

def player_quit(ev):
  player = ev.getPlayer()
  name = player.getDisplayName()
  update_gametime(name)
  return True

def update_gametime(name):
  if name not in jointime:
    return
  curtime = int(time.time())
  playtime = curtime - jointime[name]
  if name not in gametime:
    gametime[name] = 0
  gametime[name] += playtime
  save_gametime()
  del jointime[name]


def player_chat(ev):
  player = ev.getPlayer()
  name = player.getDisplayName()
  message = ev.getMessage()
  if message != "played":
    return True
  update_gametime(name)
  jointime[name] = int(time.time())
  playtime = gametime[name]
  timef = formattime(playtime)
  player.sendMessage(timef)
  return False

def formattime(seconds):
  output = ""
  years = seconds / 31536000
  if years != 0 or output != "":
    if output != "":
      output += ", "
    output += str(years) + " years"
    seconds -= 31536000*years
  months = seconds / 2628000
  if months != 0 or output != "":
    if output != "":
      output += ", "
    output += str(months) + " months"
    seconds -= 2628000*months
  days = seconds / 86400
  if days != 0 or output != "":
    if output != "":
      output += ", "
    output += str(days) + " days"
    seconds -= 86400*days
  hours = seconds / 3600
  if hours != 0 or output != "":
    if output != "":
      output += ", "
    output += str(hours) + " hours"
    seconds -= 3600*hours
  minutes = seconds / 60
  if minutes != 0 or output != "":
    if output != "":
      output += ", "
    output += str(minutes) + " minutes"
    seconds -= 60*minutes
  if output != "":
    output += ", "
  output += str(seconds) + " seconds"
  return output 
